"""Initial database

Revision ID: 100f6b705440
Revises: 
Create Date: 2015-03-25 16:35:41.711460

"""

# revision identifiers, used by Alembic.
revision = '100f6b705440'
down_revision = None
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa

import plutonium

def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('filters',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=32), nullable=False),
    sa.Column('pattern', sa.String(length=64), nullable=False),
    sa.Column('source_node', sa.String(length=64), nullable=True),
    sa.Column('type', sa.Enum('black', 'white'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('outputs',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=32), nullable=False),
    sa.Column('type', sa.String(length=32), nullable=False),
    sa.Column('params', plutonium.modules.orm.types.JSONEncoded(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('feeds',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('url', sa.Text(), nullable=False),
    sa.Column('name', sa.Text(), nullable=False),
    sa.Column('enabled', sa.Boolean(), nullable=True),
    sa.Column('output_id', sa.Integer(), nullable=False),
    sa.Column('update_interval', sa.Integer(), nullable=False),
    sa.Column('last_update', sa.DateTime(), nullable=True),
    sa.Column('target_path_pattern', sa.Text(), nullable=False),
    sa.ForeignKeyConstraint(['output_id'], ['outputs.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('feeds_filters',
    sa.Column('feed_id', sa.Integer(), nullable=True),
    sa.Column('filter_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['feed_id'], ['feeds.id'], ),
    sa.ForeignKeyConstraint(['filter_id'], ['filters.id'], )
    )
    op.create_table('torrents',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('feed_id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=255), nullable=True),
    sa.Column('title', sa.String(length=255), nullable=True),
    sa.Column('link', sa.String(length=255), nullable=True),
    sa.Column('is_sent_out', sa.Boolean(), nullable=True),
    sa.Column('added', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['feed_id'], ['feeds.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('torrents')
    op.drop_table('feeds_filters')
    op.drop_table('feeds')
    op.drop_table('outputs')
    op.drop_table('filters')
    ### end Alembic commands ###
